# HG changeset patch
# User Michael Godfrey <michaeldgodfrey@gmail.com>
# Date 1401383765 -3600
#      Thu May 29 18:16:05 2014 +0100
# Node ID b75616333fe600e56aa75bb1475c7925028cea8d
# Parent  ff613b6a7b6f780b7197f2e2bbe5dbae81c409f9
Edit Manual Sect. 1.3.3

diff -r ff613b6a7b6f -r b75616333fe6 doc/interpreter/plot.txi
--- a/doc/interpreter/plot.txi	Fri May 23 16:28:37 2014 +0200
+++ b/doc/interpreter/plot.txi	Thu May 29 18:16:05 2014 +0100
@@ -1311,9 +1311,37 @@
 * Surface Properties::
 @end menu
 
-In this Section the object properties are discussed in detail, starting
+In this Section the graphics object properties are discussed in detail, starting
 with the root figure properties and continuing through the graphics object
-hierarchy.
+hierarchy. For each graphics object its properties, with the allowed values
+(with the default value indicated by a following *), can
+be displayed using:
+
+@table @code
+@item Figure
+--- @code{set(gcf())} or @code{set(0)}
+
+@item Axes
+--- @code{set(gca())} or @code{set(axes)}
+
+@item Line
+--- @code{set(line)}
+
+@item Text
+--- @code{set(text)}
+
+@item Image
+--- @code{set(image)}
+
+@item Patch
+--- @code{set(patch)}
+
+@item Surface
+--- @code{set(surface)}
+@end table
+
+NOTE: It is appropriate to use these @code{set} functions as a check on the information shown below as
+your copy of Octave may not match the version described here.
 
 @node Root Figure Properties
 @subsubsection Root Figure Properties
@@ -1323,23 +1351,18 @@
 
 @table @code
 @item __modified__
---- Values: @qcode{"on"}, @qcode{"off"}
-
-@item __myhandle__
+--- Values: @code{[ off | on * ]}
 
 @item beingdeleted
---- Values: @qcode{"on"}, @qcode{"off"}
+--- Values: @code{[ off | on * ]}
 
 @item busyaction
+--- Values: @code{[ cancel | queue * ]}
 
 @item buttondownfcn
 
-@item callbackobject
-
-@item children
-
 @item clipping
- --- Values: @qcode{"on"}, @qcode{"off"}
+ --- Values: @code{[ off | on * ]}
 
 @item createfcn
 
@@ -1347,45 +1370,60 @@
 
 @item deletefcn
 
+@item diary
+--- Values:  @code{[ off | on * ]}
+
+@item diaryfile
+
+@item echo
+--- Values:  @code{[ off | on * ]}
+
+@item fixedwidthfontname
+
+@item format
+--- Values:  @code{[ + | bank | bit | hex | long | longe | longeng | longg | native-bit | native-hex | none | rat | short * | shorte | shorteng | shortg ]}
+
+@item formatspacing
+--- Values: @code{[ compact | loose * ]}
+
 @item handlevisibility
---- Values: @qcode{"on"}, @qcode{"off"}
+--- Values: @code{[ callback | off | on * ]}
 
 @item hittest
---- Values: @qcode{"on"}, @qcode{"off"}
+--- Values: @code{[ off | on * ]}
 
 @item interruptible
---- Values: @qcode{"on"}, @qcode{"off"}
+--- Values: @code{[ off | on * ]}
+
+@item language
+
+@item monitorpositions
 
 @item parent
 
-@item screendepth
-
-@item screenpixelsperinch
-
-@item screensize
+@item pointerlocation
+
+@item recursionlimit
 
 @item selected
+--- Values: @code{[ off | on * ]}
 
 @item selectionhighlight
-
-@item screendepth
-
-@item screenpixelsperinch
+--- Values: @code{[ off | on * ]}
 
 @item showhiddenhandles
---- Values: @qcode{"on"}, @qcode{"off"}
+--- Values: @code{[ off | on * ]}
 
 @item tag
 
-@item type
-
 @item uicontextmenu
 
 @item units
-
+--- Values: @code{[ centimeters | inches | normalized | pixels * | points ]}
 @item userdata
 
 @item visible
+--- Values: @code{[ off | on * ]}
 @end table
 
 @node Figure Properties
@@ -1398,28 +1436,21 @@
 @item __graphics_toolkit__
 --- The graphics toolkit currently in use.
 
-@item __enhanced__
-
 @item __modified__
-
-@item __myhandle__
-
-@item __plot_stream__
+--- Values: @code{[ off | on * ]}
 
 @item alphamap
 
 @item beingdeleted
---- Values: @qcode{"on"}, @qcode{"off"}
+--- Values: @code{[ off | on * ]}
 
 @item busyaction
+--- Values: @code{[ cancel | queue * ]}
 
 @item buttondownfcn
 
-@item children
-Handle to children.
-
 @item clipping
---- Values: @qcode{"on"}, @qcode{"off"}
+--- Values: @code{[ off | on * ]}
 
 @item closerequestfcn
 --- Handle of function to call on close.
@@ -1429,44 +1460,35 @@
 @item colormap
 An N-by-3 matrix containing the color map for the current axes.
 
-@item paperorientation
-
 @item createfcn
 
 @item currentaxes
 Handle to graphics object of current axes.
 
-@item currentcharacter
-
-@item currentobject
-
-@item currentpoint
-Holds the coordinates of the point over which the mouse pointer was when
-the mouse button was pressed.  If a mouse callback function is defined,
-@qcode{"currentpoint"} holds the coordinates of the point over which the
-mouse pointer is when the function gets called.
-
 @item deletefcn
 
 @item dockcontrols
---- Values: @qcode{"on"}, @qcode{"off"}
+--- Values: @code{[ off | on * ]}
 
 @item doublebuffer
---- Values: @qcode{"on"}, @qcode{"off"}
+--- Values: @code{[ off | on * ]}
 
 @item filename
 
 @item handlevisibility
---- Values: @qcode{"on"}, @qcode{"off"}
+--- Values: @code{[ callback | off | on * ]}
 
 @item hittest
+--- Values: @code{[ off | on * ]}
 
 @item integerhandle
+--- Values: @code{[ off | on * ]}
 
 @item interruptible
---- Values: @qcode{"on"}, @qcode{"off"}
+--- Values: @code{[ off | on * ]}
 
 @item inverthardcopy
+--- Values: @code{[ off | on * ]}
 
 @item keypressfcn
 see @qcode{"keypressfcn"}
@@ -1492,41 +1514,39 @@
 @end table
 
 @item menubar
-
+--- Values: @code{[ figure * | none ]}
 @item mincolormap
 
 @item name
 
 @item nextplot
-May be one of
-
-@table @asis
-@item @qcode{"new"}
-
-@item @qcode{"add"}
-
-@item @qcode{"replace"}
-
-@item @qcode{"replacechildren"}
-@end table
+--- Values: @code{[ add * | new | replace | replacechildren ]}
 
 @item numbertitle
+--- Values: @code{[ off | on * ]}
+
+@item outerposition
 
 @item paperorientation
-Indicates the orientation for printing.  Either @qcode{"landscape"} or
-@qcode{"portrait"}.
+--- Values: @code{[ landscape | portrait * | rotated ]}
 
 @item paperposition
 
 @item paperpositionmode
+--- Values: @code{[ auto | manual * ]}
 
 @item papersize
 
 @item papertype
+--- Values: @code{[ <custom> | a | a0 | a1 | a2 | a3 | a4 | a5 | arch-a | arch-b | arch-c | arch-d | arch-e | b | b0 | b1 | b2 | b3 | b4 | b5 | c | d | e | tabloid | uslegal | usletter * ]}
 
 @item paperunits
+--- Values: @code{[ centimeters | inches * | normalized | points ]}
+
+@item parent
 
 @item pointer
+--- Values: @code{[ arrow * | botl | botr | bottom | circle | cross | crosshair | custom | fleur | fullcrosshair | hand | ibeam | left | right | top | topl | topr | watch ]}
 
 @item pointershapecdata
 
@@ -1535,32 +1555,39 @@
 @item position
 
 @item renderer
+--- Values: @code{[ none | opengl | painters * | zbuffer ]}
 
 @item renderermode
+--- Values: @code{[ auto * | manual ]}
 
 @item resize
+--- Values: @code{[ off | on * ]}
 
 @item resizefcn
 
 @item selected
+--- Values: @code{[ off | on * ]}
 
 @item selectionhighlight
---- Values: @qcode{"on"}, @qcode{"off"}
+--- Values: @code{[ off | on * ]}
 
 @item selectiontype
+--- Values: @code{[ alt | extend | normal * | open ]}
 
 @item tag
 
 @item toolbar
-
-@item type
+--- Values: @code{[ auto * | figure | none ]}
+
+@item uicontextmenu
 
 @item units
+--- Values: @code{[ centimeters | characters | inches | normalized | pixels * | points ]}
 
 @item userdata
 
 @item visible
-Either @qcode{"on"} or @qcode{"off"} to toggle display of the figure.
+--- Values: @code{[ off | on * ]}
 
 @item windowbuttondownfcn
 See @qcode{"windowbuttonupfcn"}
@@ -1575,19 +1602,27 @@
 these callback functions are called, the @qcode{"currentpoint"} property
 holds the current coordinates of the cursor.
 
+@item windowkeypressfcn
+
+@item windowkeyreleasefcn
+
 @item windowscrollwheelfcn
 
 @item windowstyle
+--- Values: @code{[ docked | modal | normal * ]}
 
 @item wvisual
 
 @item wvisualmode
+--- Values: @code{[ auto * | manual ]}
 
 @item xdisplay
 
 @item xvisual
 
 @item xvisualmode
+--- Values: @code{[ auto * | manual ]}
+
 @end table
 
 @node Axes Properties
@@ -1598,42 +1633,48 @@
 
 @table @code
 @item __modified__
-
-@item __myhandle__
+--- Values: @code{[ off | on * ]}
 
 @item activepositionproperty
+--- Values: @code{[ outerposition * | position ]}
 
 @item alim
 
 @item alimmode
+--- Values: @code{[ auto * | manual ]}
 
 @item ambientlightcolor
 
 @item beingdeleted
+--- Values: @code{[ off | on * ]}
 
 @item box
-Box surrounding axes.
---- Values: @qcode{"on"}, @qcode{"off"}
+--- Values: @code{[ off | on * ]}
 
 @item busyaction
+--- Values: @code{[ cancel | queue * ]}
 
 @item buttondownfcn
 
 @item cameraposition
 
 @item camerapositionmode
+--- Values: @code{[ auto * | manual ]}
 
 @item cameratarget
 
 @item cameratargetmode
+--- Values: @code{[ auto * | manual ]}
 
 @item cameraupvector
 
 @item cameraupvectormode
+--- Values: @code{[ auto * | manual ]}
 
 @item cameraviewangle
 
 @item cameraviewanglemode
+--- Values: @code{[ auto * | manual ]}
 
 @item children
 